﻿using System;

namespace ChainOfResponsability.Ejm1
{
    /// <summary>
    /// Manejador de Solicitudes de Compra. Clase abstracta que define la interfaz común de todos 
    /// los potenciales controladores
    /// </summary>
    public abstract class PRHandler
    {
        private PRHandler NextHandler;
        private string NandlerName;

        public PRHandler(String name)
        {
            NandlerName = name;
        }

        public String getName()
        {
            return NandlerName;
        }

        public abstract bool Authorize(PurchaseRequest request);

        public PRHandler GetNextHandler()
        {
            return NextHandler;
        }

        public void SetNextHandler(PRHandler handler)
        {
            NextHandler = handler;
        }
    }
}
