﻿using System;
namespace ChainOfResponsability.Ejm1
{
    /// <summary>
    /// Director regional
    /// </summary>
    public class RegionalDirector : PRHandler
    {
        private const double Limit = 100000;

        public RegionalDirector(String name)
            : base(name)
        {

        }

        public override bool Authorize(PurchaseRequest request)
        {
            double amount = request.GetAmount();
            if (amount <= Limit)
            {
                Console.WriteLine("Regional Director " + getName()
                        + " has authorized the PR  " + request);
                return true;
            }
            else
            {
                // forward the request to the next handler
                return GetNextHandler().Authorize(request);
            }
        }
    }
}
