﻿using System;
using ChainOfResponsability.Ejm1;
namespace ChainOfResponsability
{
    /// <summary>
    /// Cliente
    /// </summary>
    public class PRManager
    {
        private BranchManager branchManager;
        private RegionalDirector regionalDirector;
        private VicePresident vicePresident;
        private PresidentCOO coo;

        static void Main(string[] args)
        {
            PRManager manager = new PRManager();
            manager.createAuthorizationFlow();

            PurchaseRequest request = new PurchaseRequest(1, "Office Supplies",
                    10000);
            manager.branchManager.Authorize(request);

            request = new PurchaseRequest(2, "HardWare Procurement", 175000);
            manager.branchManager.Authorize(request);

            request = new PurchaseRequest(3, "AD Campaign", 800000);
            manager.branchManager.Authorize(request);
            Console.ReadKey();
        }

        public void createAuthorizationFlow()
        {
            branchManager = new BranchManager("Robin");
            regionalDirector = new RegionalDirector("Oscar");
            vicePresident = new VicePresident("Kate");
            coo = new PresidentCOO("Drew");
            // Crea los enlaces
            branchManager.SetNextHandler(regionalDirector);
            regionalDirector.SetNextHandler(vicePresident);
            vicePresident.SetNextHandler(coo);
        }
    }
}
